What is a throw keyword c#


C# - throw keyword

We have seen in the previous section how to handle exceptions which are automatically raised by CLR. Here, we will see how to raise an exception manually.
An exception can be raised manually by using the throw keyword. Any type of exceptions which is derived from Exception class can be raised using the throw keyword.
Example: throw an exception
  1. static void Main(string[] args)
    {
        Student std = null;
    
        try
        {
            PrintStudentName(std);
        }
        catch(Exception ex)
        {
            Console.WriteLine(ex.Message );
        }                      
    
        Console.ReadKey();
    }
    
    private static void PrintStudentName( Student std)
    {
        if (std  == null)
            throw new NullReferenceException("Student object is null.");
            
        Console.WriteLine(std.StudentName);
    }

In the above example, PrintStudentName() method raises NullReferenceException if Student object is null.
Please notice that throw creates an object of any valid exception type using the new keyword. The throw keyword cannot be used with any other type which does not derive from the Exception class.

Re-throwing an Exception

You can also re-throw an exception from the catch block to pass on to the caller and let the caller handle it the way they want. The following example re-throws an exception.
Example: throw an exception
  1. static void Main(string[] args)
    {
        try
        {
            Method1();
        }
        catch(Exception ex)
        {
            Console.WriteLine(ex.StackTrace);
        }                      
    }
    
    static void Method1()
    {
        try
        {
            Method2();
        }
        catch(Exception ex)
        {
            throw;
        } 
    }
    
    static void Method2()
    {
        string str = null;
        try
        {
            Console.WriteLine(str[0]);
        }
        catch(Exception ex)
        {
            throw;
        } 
    }

In the above example, an exception occurs in Method2(). The catch block simply throws that exception using only throw keyword (not throw e). This will be handled in catch block in Method1() where it again re-throw the same exception and finally it is being handled in the Main() method. The stack trace of this exception will give you the full detail of where exactly this exception occurred.
If you re-throw an exception using exception parameter then it will not preserve the original exception and creates a new exception. The following example demonstrates this.
Example: throw an exception

  1. static void Main(string[] args)
    {
        try
        {
            Method1();
        }
        catch(Exception ex)
        {
            Console.WriteLine(ex.StackTrace);
        }                      
    }
    
    static void Method1()
    {
        try
        {
            Method2();
        }
        catch(Exception ex)
        {
            throw ex;
        } 
    }
    
    static void Method2()
    {
        string str = null;
        try
        {
            Console.WriteLine(str[0]);
        }
        catch(Exception ex)
        {
            throw;
        } 
    }



Post a Comment

0 Comments